# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic
    if pydantic.__version__.startswith("1."):
        raise ImportError
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class BasePromptTemplate(pydantic.BaseModel):
    metadata: typing.Dict[str, typing.Any]
    template_vars: typing.List[str]
    kwargs: typing.Dict[str, str]
    output_parser: typing.Any
    template_var_mappings: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description="Template variable mappings (Optional)."
    )
    function_mappings: typing.Optional[typing.Dict[str, typing.Optional[str]]] = pydantic.Field(
        description="Function mappings (Optional). This is a mapping from template variable names to functions that take in the current kwargs and return a string."
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
