# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic
    if pydantic.__version__.startswith("1."):
        raise ImportError
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class BedrockEmbedding(pydantic.BaseModel):
    model_name: typing.Optional[str] = pydantic.Field(description="The modelId of the Bedrock model to use.")
    embed_batch_size: typing.Optional[int] = pydantic.Field(description="The batch size for embedding calls.")
    num_workers: typing.Optional[int] = pydantic.Field(
        description="The number of workers to use for async embedding calls."
    )
    profile_name: typing.Optional[str] = pydantic.Field(
        description="The name of aws profile to use. If not given, then the default profile is used."
    )
    aws_access_key_id: typing.Optional[str] = pydantic.Field(description="AWS Access Key ID to use")
    aws_secret_access_key: typing.Optional[str] = pydantic.Field(description="AWS Secret Access Key to use")
    aws_session_token: typing.Optional[str] = pydantic.Field(description="AWS Session Token to use")
    region_name: typing.Optional[str] = pydantic.Field(
        description="AWS region name to use. Uses region configured in AWS CLI if not passed"
    )
    max_retries: typing.Optional[int] = pydantic.Field(description="The maximum number of API retries.")
    timeout: typing.Optional[float] = pydantic.Field(
        description="The timeout for the Bedrock API request in seconds. It will be used for both connect and read timeouts."
    )
    additional_kwargs: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description="Additional kwargs for the bedrock client."
    )
    class_name: typing.Optional[str]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
