# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .pooling import Pooling
from .token import Token

try:
    import pydantic
    if pydantic.__version__.startswith("1."):
        raise ImportError
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class HuggingFaceInferenceApiEmbedding(pydantic.BaseModel):
    model_name: typing.Optional[str] = pydantic.Field(
        description="Hugging Face model name. If None, the task will be used."
    )
    embed_batch_size: typing.Optional[int] = pydantic.Field(description="The batch size for embedding calls.")
    num_workers: typing.Optional[int] = pydantic.Field(
        description="The number of workers to use for async embedding calls."
    )
    pooling: typing.Optional[Pooling] = pydantic.Field(
        description="Pooling strategy. If None, the model's default pooling is used."
    )
    query_instruction: typing.Optional[str] = pydantic.Field(
        description="Instruction to prepend during query embedding."
    )
    text_instruction: typing.Optional[str] = pydantic.Field(description="Instruction to prepend during text embedding.")
    token: typing.Optional[Token] = pydantic.Field(
        description="Hugging Face token. Will default to the locally saved token. Pass token=False if you don’t want to send your token to the server."
    )
    timeout: typing.Optional[float] = pydantic.Field(
        description="The maximum number of seconds to wait for a response from the server. Loading a new model in Inference API can take up to several minutes. Defaults to None, meaning it will loop until the server is available."
    )
    headers: typing.Optional[typing.Dict[str, typing.Optional[str]]] = pydantic.Field(
        description="Additional headers to send to the server. By default only the authorization and user-agent headers are sent. Values in this dictionary will override the default values."
    )
    cookies: typing.Optional[typing.Dict[str, typing.Optional[str]]] = pydantic.Field(
        description="Additional cookies to send to the server."
    )
    task: typing.Optional[str] = pydantic.Field(
        description="Optional task to pick Hugging Face's recommended model, used when model_name is left as default of None."
    )
    class_name: typing.Optional[str]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
